# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from cloudendure.cloudendure_api.api_client import ApiClient


class CloudApi:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def cloud_credentials_creds_id_regions_get(self, creds_id, **kwargs):  # noqa: E501
        """List Regions  # noqa: E501

        Returns the list of regions these credentials provide access to.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_get(creds_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param int offset: With which item to start (0 based).
        :param int limit: A number specifying how many entries to return.
        :return: CloudEndureRegionsList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.cloud_credentials_creds_id_regions_get_with_http_info(
                creds_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.cloud_credentials_creds_id_regions_get_with_http_info(
                creds_id, **kwargs
            )  # noqa: E501
            return data

    def cloud_credentials_creds_id_regions_get_with_http_info(
        self, creds_id, **kwargs
    ):  # noqa: E501
        """List Regions  # noqa: E501

        Returns the list of regions these credentials provide access to.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_get_with_http_info(creds_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param int offset: With which item to start (0 based).
        :param int limit: A number specifying how many entries to return.
        :return: CloudEndureRegionsList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["creds_id", "offset", "limit"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cloud_credentials_creds_id_regions_get" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'creds_id' is set
        if "creds_id" not in params or params["creds_id"] is None:
            raise ValueError(
                "Missing the required parameter `creds_id` when calling `cloud_credentials_creds_id_regions_get`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "creds_id" in params:
            path_params["credsId"] = params["creds_id"]  # noqa: E501

        query_params = []
        if "offset" in params:
            query_params.append(("offset", params["offset"]))  # noqa: E501
        if "limit" in params:
            query_params.append(("limit", params["limit"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/cloudCredentials/{credsId}/regions",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="CloudEndureRegionsList",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def cloud_credentials_creds_id_regions_region_id_delete(
        self, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Delete region (VCenter)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_delete(creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.cloud_credentials_creds_id_regions_region_id_delete_with_http_info(
                creds_id, region_id, **kwargs
            )  # noqa: E501
        else:
            (
                data
            ) = self.cloud_credentials_creds_id_regions_region_id_delete_with_http_info(
                creds_id, region_id, **kwargs
            )  # noqa: E501
            return data

    def cloud_credentials_creds_id_regions_region_id_delete_with_http_info(
        self, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Delete region (VCenter)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_delete_with_http_info(creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["creds_id", "region_id"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cloud_credentials_creds_id_regions_region_id_delete"
                    % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'creds_id' is set
        if "creds_id" not in params or params["creds_id"] is None:
            raise ValueError(
                "Missing the required parameter `creds_id` when calling `cloud_credentials_creds_id_regions_region_id_delete`"
            )  # noqa: E501
        # verify the required parameter 'region_id' is set
        if "region_id" not in params or params["region_id"] is None:
            raise ValueError(
                "Missing the required parameter `region_id` when calling `cloud_credentials_creds_id_regions_region_id_delete`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "creds_id" in params:
            path_params["credsId"] = params["creds_id"]  # noqa: E501
        if "region_id" in params:
            path_params["regionId"] = params["region_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/cloudCredentials/{credsId}/regions/{regionId}",
            "DELETE",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def cloud_credentials_creds_id_regions_region_id_get(
        self, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Get Region  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_get(creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: CloudEndureRegion
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.cloud_credentials_creds_id_regions_region_id_get_with_http_info(
                creds_id, region_id, **kwargs
            )  # noqa: E501
        else:
            (
                data
            ) = self.cloud_credentials_creds_id_regions_region_id_get_with_http_info(
                creds_id, region_id, **kwargs
            )  # noqa: E501
            return data

    def cloud_credentials_creds_id_regions_region_id_get_with_http_info(
        self, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Get Region  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_get_with_http_info(creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: CloudEndureRegion
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["creds_id", "region_id"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cloud_credentials_creds_id_regions_region_id_get" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'creds_id' is set
        if "creds_id" not in params or params["creds_id"] is None:
            raise ValueError(
                "Missing the required parameter `creds_id` when calling `cloud_credentials_creds_id_regions_region_id_get`"
            )  # noqa: E501
        # verify the required parameter 'region_id' is set
        if "region_id" not in params or params["region_id"] is None:
            raise ValueError(
                "Missing the required parameter `region_id` when calling `cloud_credentials_creds_id_regions_region_id_get`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "creds_id" in params:
            path_params["credsId"] = params["creds_id"]  # noqa: E501
        if "region_id" in params:
            path_params["regionId"] = params["region_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/cloudCredentials/{credsId}/regions/{regionId}",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="CloudEndureRegion",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def cloud_credentials_creds_id_regions_region_id_patch(
        self, body, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Patch region (rename)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_patch(body, creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloudEndureRegion body: (required)
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: CloudEndureRegion
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.cloud_credentials_creds_id_regions_region_id_patch_with_http_info(
                body, creds_id, region_id, **kwargs
            )  # noqa: E501
        else:
            (
                data
            ) = self.cloud_credentials_creds_id_regions_region_id_patch_with_http_info(
                body, creds_id, region_id, **kwargs
            )  # noqa: E501
            return data

    def cloud_credentials_creds_id_regions_region_id_patch_with_http_info(
        self, body, creds_id, region_id, **kwargs
    ):  # noqa: E501
        """Patch region (rename)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cloud_credentials_creds_id_regions_region_id_patch_with_http_info(body, creds_id, region_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloudEndureRegion body: (required)
        :param str creds_id: UUID of the credentials to use. In case of on-premise, you should use the null UUID \"00000000-0000-0000-0000-000000000000\".  (required)
        :param str region_id: (required)
        :return: CloudEndureRegion
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["body", "creds_id", "region_id"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cloud_credentials_creds_id_regions_region_id_patch"
                    % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'body' is set
        if "body" not in params or params["body"] is None:
            raise ValueError(
                "Missing the required parameter `body` when calling `cloud_credentials_creds_id_regions_region_id_patch`"
            )  # noqa: E501
        # verify the required parameter 'creds_id' is set
        if "creds_id" not in params or params["creds_id"] is None:
            raise ValueError(
                "Missing the required parameter `creds_id` when calling `cloud_credentials_creds_id_regions_region_id_patch`"
            )  # noqa: E501
        # verify the required parameter 'region_id' is set
        if "region_id" not in params or params["region_id"] is None:
            raise ValueError(
                "Missing the required parameter `region_id` when calling `cloud_credentials_creds_id_regions_region_id_patch`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "creds_id" in params:
            path_params["credsId"] = params["creds_id"]  # noqa: E501
        if "region_id" in params:
            path_params["regionId"] = params["region_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/cloudCredentials/{credsId}/regions/{regionId}",
            "PATCH",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="CloudEndureRegion",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def clouds_get(self, **kwargs):  # noqa: E501
        """List Clouds  # noqa: E501

        Returns a list of clouds that can be used with CloudEndure. The roles array determines whether this cloud can be used as source, target, or both.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.clouds_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int offset: With which item to start (0 based).
        :param int limit: A number specifying how many entries to return.
        :return: CloudEndureCloudsList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.clouds_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.clouds_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def clouds_get_with_http_info(self, **kwargs):  # noqa: E501
        """List Clouds  # noqa: E501

        Returns a list of clouds that can be used with CloudEndure. The roles array determines whether this cloud can be used as source, target, or both.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.clouds_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int offset: With which item to start (0 based).
        :param int limit: A number specifying how many entries to return.
        :return: CloudEndureCloudsList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["offset", "limit"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method clouds_get" % key
                )
            params[key] = val
        del params["kwargs"]

        collection_formats = {}

        path_params = {}

        query_params = []
        if "offset" in params:
            query_params.append(("offset", params["offset"]))  # noqa: E501
        if "limit" in params:
            query_params.append(("limit", params["limit"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/clouds",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="CloudEndureCloudsList",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )
