# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class CloudEndureSamlSettings:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "identity_provider_certificate": "str",
        "identity_provider_url": "str",
        "identity_provider_id": "str",
    }

    attribute_map = {
        "identity_provider_certificate": "identityProviderCertificate",
        "identity_provider_url": "identityProviderUrl",
        "identity_provider_id": "identityProviderID",
    }

    def __init__(
        self,
        identity_provider_certificate=None,
        identity_provider_url=None,
        identity_provider_id=None,
    ):  # noqa: E501
        """CloudEndureSamlSettings - a model defined in Swagger"""  # noqa: E501
        self._identity_provider_certificate = None
        self._identity_provider_url = None
        self._identity_provider_id = None
        self.discriminator = None
        if identity_provider_certificate is not None:
            self.identity_provider_certificate = identity_provider_certificate
        if identity_provider_url is not None:
            self.identity_provider_url = identity_provider_url
        if identity_provider_id is not None:
            self.identity_provider_id = identity_provider_id

    @property
    def identity_provider_certificate(self):
        """Gets the identity_provider_certificate of this CloudEndureSamlSettings.  # noqa: E501


        :return: The identity_provider_certificate of this CloudEndureSamlSettings.  # noqa: E501
        :rtype: str
        """
        return self._identity_provider_certificate

    @identity_provider_certificate.setter
    def identity_provider_certificate(self, identity_provider_certificate):
        """Sets the identity_provider_certificate of this CloudEndureSamlSettings.


        :param identity_provider_certificate: The identity_provider_certificate of this CloudEndureSamlSettings.  # noqa: E501
        :type: str
        """

        self._identity_provider_certificate = identity_provider_certificate

    @property
    def identity_provider_url(self):
        """Gets the identity_provider_url of this CloudEndureSamlSettings.  # noqa: E501


        :return: The identity_provider_url of this CloudEndureSamlSettings.  # noqa: E501
        :rtype: str
        """
        return self._identity_provider_url

    @identity_provider_url.setter
    def identity_provider_url(self, identity_provider_url):
        """Sets the identity_provider_url of this CloudEndureSamlSettings.


        :param identity_provider_url: The identity_provider_url of this CloudEndureSamlSettings.  # noqa: E501
        :type: str
        """

        self._identity_provider_url = identity_provider_url

    @property
    def identity_provider_id(self):
        """Gets the identity_provider_id of this CloudEndureSamlSettings.  # noqa: E501


        :return: The identity_provider_id of this CloudEndureSamlSettings.  # noqa: E501
        :rtype: str
        """
        return self._identity_provider_id

    @identity_provider_id.setter
    def identity_provider_id(self, identity_provider_id):
        """Sets the identity_provider_id of this CloudEndureSamlSettings.


        :param identity_provider_id: The identity_provider_id of this CloudEndureSamlSettings.  # noqa: E501
        :type: str
        """

        self._identity_provider_id = identity_provider_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(CloudEndureSamlSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEndureSamlSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
